/**
 ** REXX:HTMLedit.ttx  v. 1.0  February 19, 1995
 ** Author: Clete Baker (cletus@gonix.com)
 **
 ** This script launches certain of the HTML Heaven suite of programs,
 ** resizes the TurboText window to accomodate them, and cancels
 ** the Word Wrap function.  You will need to edit this script to
 ** your own preferences according to the comments below.
 **
 ** This can be made into a menu item by editing TTX_Startup.dfn
 ** to include the line:
 ** 
 **   ITEM "Edit HTML"         ""  ExecARexxMacro REXX:HTMLedit.ttx
 **
 ** as the last item under the "Windows" menu (or other menu
 ** location of your choice.
 **/

options results                        /* get results                    */
Address 'TURBOTEXT' 'ActivateLastDoc'  /* capture address of calling doc */
Address value result                   /* ... and direct output to it    */

GetWindowInfo                          /* snag current window parameters */
parse upper var result icon x y width height minwidth minheight numviews

/**
 ** Set your own defaults here; these work fine for me on
 ** my NTSC screen.  You may have to do some empirical
 ** playing to find the right values for you.  You'll also
 ** have to replace "TurboText:Support/<progname>" in the
 ** following with the correct path to your copies of the
 ** HTML Heaven programs.  At the same time you'll want to
 ** apply whichever tooltype/startup parameters you wish
 ** for each of the programs.  Try offset = 60 for HTML-Helper;
 ** offset = 42 for HTML-Genie.
 **/

offset  = 42                          /* how far do we drop TTX's screen? */
helper  = 'run >nil: TurboText:Support/HTML-Helper PUBSCREEN=TURBOTEXT'
toolkit = 'run >nil: TurboText:Support/Toolkit PUBSCREEN=TURBOTEXT TOPEDGE=230 LEFTEDGE=486'
heaven  = 'run >nil: TurboText:Support/HTML-Genie PUBSCREEN=TURBOTEXT'

/**
 ** Making sure that the height with offset applied doesn't
 ** drop below the minimum height for TurboText windows, apply
 ** the offset to the top of TurboText's current window, leaving
 ** bottom and side positions alone.
 **/

if ~((height-offset) < minheight) then do
   MoveSizeWindow x (y+offset) width (height-offset)
   end
else exit

SetPrefs WordWrap OFF                  /* you may prefer to leave WW ON  */

/**
 ** Address command helper             /* open HTML-Helper on TTX screen */
 **/
Address command toolkit                /* open Toolkit on TTX screen     */
Address command heaven                 /* open HTML-Genie on TTX screen  */

exit
